Description

For discussion on equals see also #7155 and related tickets.

Does anybody remember a reason why created is compared in CdmBase.equals?

Related issues:

Related to EDIT - bug #7155: VersionableEntity.equals() should take updated t... Closed
Related to EDIT - feature request #7198: Implement equals() forCategoricalData Rejected
Related to EDIT - feature request #7199: Implement equals() for QuantitativeData Rejected
Related to EDIT - task #7202: [DISCUSS] Can we remove equals override from so... New

Associated revisions

Revision 579a4a81 - 01/18/2018 11:45 AM - Andreas Miiller

ref #7201 remove created from equals and remove equals override in TermBase

e the new CdmBase.equals implementation should now be equivalent to old TermBase.equals

Revision 5069790f - 01/18/2018 11:53 AM - Andreas Miiller

ref #7201, ref #7155 remove equals override also from OrderedTermBase

Revision bef37262 - 01/18/2018 12:14 PM - Andreas Miiller
ref #7201, ref #7155 javadoc

Revision 04af63c0 - 01/18/2018 12:16 PM - Andreas Miiller

ref #7201, ref #7155 revert setting to final in CdmBase (was not on purpose)

History

#1-01/18/2018 10:37 AM - Andreas Miiller
- Related to bug #7155: VersionableEntity.equals() should take updated timestamp into account added

#2 - 01/18/2018 10:37 AM - Andreas Miiller

- Related to feature request #7198: Implement equals() forCategoricalData added

#3 - 01/18/2018 10:37 AM - Andreas Miiller

- Related to feature request #7199: Implement equals() for QuantitativeData added

#4 - 01/18/2018 10:53 AM - Andreas Miiller
AK:

Ich erinnere mich an keinen Grund weshalb das Create verglichen wird. Falls mir noch einer einféllt sage ich Bescheid.

#5-01/18/2018 11:10 AM - Andreas Kohlbecker

Andreas Muller wrote:

AK:
https://dev.e-taxonomy.eu/redmine/issues/7155

Ich erinnere mich an keinen Grund weshalb das Create verglichen wird. Falls mir noch einer einféllt sage ich Bescheid.
Vielleicht um "re-importierte" entities unterscheiden zu kénnen? Diese hétten die selbe UUID aber eine andere id. Wirden in der equals
methode die ids verglichen wére dies nicht nétig.

Die Implementierung clone Methode ist in dieser Hinsicht ganz interessant:

result.setId(0);
result.setUuid (UUID.randomUUID()) ;
result.setCreated(new DateTime());
result.setCreatedBy (null);

demnach waren in der derzeitigen Implementierung Klone nicht equal zum Original, ich denke das macht Sinn.

Ach Ubrigens, da wir schon beim Thema sind, in https://developer.jboss.org/wiki/EqualsAndHashCode wird darauf hingewiesen, dass equals() und
hashCode() immer &quivalent implementiert werden sollten. hashCode() wird in CmdBase aber nicht Gberschrieben. Ist das bewusst so o der wurde
das vergessen?

#6 - 01/18/2018 11:37 AM - Andreas Miiller
Andreas Kohlbecker wrote:
Ach Ubrigens, da wir schon beim Thema sind, in https://developer.jboss.org/wiki/EqualsAndHashCode wird darauf hingewiesen, dass equals()

und hashCode() immer &quivalent implementiert werden sollten. hashCode() wird in CmdBase aber nicht Gberschrieben. Ist das bewusst so o
der wurde das vergessen?

Doch, es wird Uberschrieben. Steht direkt unter equals. Dort wird iberigens auch nur die uuid fiir die Berechnung des HashCodes verwendet. Spricht
auch dafir, dass wir das created rausnehmen sollten (oder mit in die HashCode Berechnung aufnehmen sollten).

#7 - 01/18/2018 11:37 AM - Andreas Miiller

- Target version changed from Unassigned CDM tickets to Release 4.13

#8 - 01/18/2018 11:58 AM - Andreas Miiller
- Status changed from New to Resolved

- Assignee changed from Andreas Miiller to Katja Luther

As TermBase and OrderedTermBase also had there own implementation but without created comparison | did now remove the created comparison
from CdmBase.equals().

So everybode should carefully check if everything still works as expected, also with DefinedTerms and OrderedTerms as | did remove the equals
implementation from their to be able to set equals to final in VersionableEntity (and maybe later also in CdmBase).

#9 - 01/18/2018 11:58 AM - Andreas Miiller
- % Done changed from 0 to 70

#10 - 01/18/2018 12:07 PM - Andreas Miiller

- Related to task #7202: [DISCUSS] Can we remove equals override from some classes directly inheriting from CdmBase added

#11 - 02/16/2018 01:01 PM - Katja Luther
- Status changed from Resolved to Closed

- Assignee changed from Katja Luther to Andreas Mdiller

seems logically correct and as long as | see everything works
